---
title: Element.toggleAttribute()
slug: Web/API/Element/toggleAttribute
tags:
  - API
  - Element
  - Method
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>toggleAttribute()</strong></code> method of the {{domxref("Element")}} interface toggles a Boolean attribute (removing it if it is present and adding it if it is not present) on the given element.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>Element</em>.toggleAttribute(<em>name</em> [, <em>force</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code>name</code></dt>
	<dd>A {{domxref("DOMString")}} specifying the name of the attribute to be toggled. The attribute name is automatically converted to all lower-case when <code>toggleAttribute()</code> is called on an HTML element in an HTML document.</dd>
	<dt><code>force</code> {{optional_inline}}</dt>
	<dd>A boolean value to determine whether the attribute should be added or removed, no matter whether the attribute is present or not at the moment.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>true</code> if attribute <strong><code>name</code></strong> is eventually present, and <code>false</code> otherwise.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
	<dt><code>InvalidCharacterError</code></dt>
	<dd>The specified attribute <code>name</code> contains one or more characters which are not valid in attribute names.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>In the following example, <code>toggleAttribute()</code> is used to toggle the <code>readonly</code> attribute of a {{HTMLElement("input")}}.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;input value="text"&gt;
&lt;button&gt;toggleAttribute("readonly")&lt;/button&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush:js">var button = document.querySelector("button");
var input = document.querySelector("input");

button.addEventListener("click", function(){
  input.toggleAttribute("readonly");
});
</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Example', '300', '50') }}</p>

<p>{{DOMAttributeMethods}}</p>

<h2 id="Polyfill">Polyfill</h2>

<pre class="brush: js">if (!Element.prototype.toggleAttribute) {
  Element.prototype.toggleAttribute = function(name, force) {
    if(force !== void 0) force = !!force

    if (this.hasAttribute(name)) {
      if (force) return true;

      this.removeAttribute(name);
      return false;
    }
    if (force === false) return false;

    this.setAttribute(name, "");
    return true;
  };
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#dom-element-toggleattribute', 'Element.toggleAttribute')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td> </td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.toggleAttribute")}}</p>
